<template>
  <div>
    <div class="auth__title">{{ $t('auth.register') }}</div>
    <form class="auth__form" @submit.prevent="onSubmit">
      <div class="auth__row">
        <div class="auth__half">
          <el-input
            v-model="form.login"
            type="email"
            :placeholder="$t('email')"
          />
        </div>
        <div class="auth__half">
          <el-input
            v-model="form.password"
            type="password"
            :placeholder="$t('password')"
          />
        </div>
        <div class="auth__half">
          <el-input
            v-model="form.passwordAgain"
            type="password"
            :placeholder="$t('auth.password_again')"
          />
        </div>
        <div class="auth__half">
          <Button type="submit" variant="success">
            {{ $t('finish') }}
          </Button>
        </div>
      </div>
    </form>
    <Alert v-if="error" variant="danger">
      {{ $t('errors.' + error) }}
    </Alert>
    <!-- <div class="auth__connect">
      <div class="auth__connect_title">{{ $t('auth.easy_way') }}</div>
      <div class="auth__row">
        <div class="auth__half">
          <Button class="auth__google" variant="light">
            <svg-icon name="google" />
            <span>{{ $t('auth.login_with_google') }}</span>
          </Button>
        </div>
        <div class="auth__half">
          <Button :to="localePath('/auth/login')" variant="white-opacity">
            {{ $t('auth.login') }}
          </Button>
        </div>
      </div>
    </div> -->
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  reactive,
  ref,
  useContext
} from '@nuxtjs/composition-api'
import isEmail from 'validator/lib/isEmail'

import elInput from '@/components/element/Input.vue'
import Button from '@/components/ui/Button.vue'
import Alert from '@/components/ui/Alert.vue'

import type { ErrorKey } from '@/lang/en-US'

export default defineComponent({
  layout: 'auth',
  name: 'AuthRegisterPage',
  components: { elInput, Button, Alert },
  setup() {
    const form = reactive({
      login: '',
      password: '',
      passwordAgain: '',
      loading: false
    })

    const error = ref<ErrorKey | null>(null)
    const { app } = useContext()

    async function onSubmit() {
      if (form.loading) return
      if (!isEmail(form.login)) {
        error.value = 'email_not_valid'
        return
      }

      if (form.password.length < 8) {
        error.value = 'password_not_valid'
        return
      }

      if (form.password !== form.passwordAgain) {
        error.value = 'password_again'
        return
      }

      form.loading = true
      try {
        await app.$api.auth.register(form.login, form.password)
        await app.$api.auth.login(form.login, form.password)
      } catch (err) {
        console.error(err)
        switch (err?.response?.data?.message) {
          case 'Account already exists.':
            error.value = 'account_already_exists'
            break

          default:
            error.value = 'oops'
        }
      }
      form.loading = false
    }

    return {
      form,
      error,
      onSubmit
    }
  }
})
</script>
